function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["itemData", "checked", "checkable", "checkbox", "checkboxProps", "checkboxPosition", "position", "avatar", "author", "content"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { forwardRef, useRef, useImperativeHandle } from 'react';

// 内库使用-start
import Checkbox from "./../../Checkbox";
// 内库使用-end

/* 测试使用-start
import { Checkbox } from 'seedsui-react'
测试使用-end */

var Chat = function Chat(_ref, ref) {
  var itemData = _ref.itemData,
    checked = _ref.checked,
    checkable = _ref.checkable,
    checkbox = _ref.checkbox,
    checkboxProps = _ref.checkboxProps,
    _ref$checkboxPosition = _ref.checkboxPosition,
    checkboxPosition = _ref$checkboxPosition === void 0 ? 'left' : _ref$checkboxPosition,
    position = _ref.position,
    avatar = _ref.avatar,
    author = _ref.author,
    content = _ref.content,
    props = _objectWithoutProperties(_ref, _excluded);
  // 节点
  var rootRef = useRef(null);
  useImperativeHandle(ref, function () {
    return {
      rootDOM: rootRef.current,
      getRootDOM: function getRootDOM() {
        return rootRef.current;
      }
    };
  });

  // 渲染头像
  function getAvatarNode() {
    if (!avatar) return null;
    if (typeof avatar === 'function') {
      return avatar(_objectSpread(_objectSpread({}, itemData || {}), {}, {
        checked: checked
      }));
    }
    if (typeof avatar === 'string') {
      return /*#__PURE__*/React.createElement("div", {
        className: "chat-item-avatar"
      }, /*#__PURE__*/React.createElement("img", {
        alt: "",
        src: avatar,
        onError: function onError(e) {
          e.target.classList.add('fail');
        },
        onLoad: function onLoad(e) {
          e.target.classList.add('success');
        },
        className: "avatar"
      }));
    }
    return avatar;
  }

  // 渲染作者
  function getAuthorNode() {
    if (!author) return null;
    if (typeof author === 'function') {
      return author(_objectSpread(_objectSpread({}, itemData || {}), {}, {
        checked: checked
      }));
    }
    if (typeof author === 'string') {
      return /*#__PURE__*/React.createElement("div", {
        className: "chat-item-content-author"
      }, author);
    }
    return author;
  }

  // 获取checkbox
  function getCheckboxNode() {
    if (!checkable) return null;
    if (typeof checkbox === 'function') {
      var newCheckBox = checkbox(_objectSpread(_objectSpread({}, itemData || {}), {}, {
        checked: checked,
        checkboxProps: checkboxProps
      }));
      if (newCheckBox !== undefined) return newCheckBox;
    }
    return /*#__PURE__*/React.createElement(Checkbox, _extends({
      checked: checked
    }, checkboxProps));
  }
  return /*#__PURE__*/React.createElement("div", _extends({}, props, {
    className: "chat-item".concat(position ? ' ' + position : '').concat(props.className ? ' ' + props.className : ''),
    ref: rootRef
  }), checkboxPosition !== 'right' && getCheckboxNode(checked), /*#__PURE__*/React.createElement("div", {
    className: "chat-item-main"
  }, getAvatarNode(), /*#__PURE__*/React.createElement("div", {
    className: "chat-item-content"
  }, getAuthorNode(), /*#__PURE__*/React.createElement("div", {
    className: "chat-item-content-bubble"
  }, content))), checkboxPosition === 'right' && getCheckboxNode(checked));
};
export default /*#__PURE__*/forwardRef(Chat);